package itcr.mathexplorer.constantes;

import itcr.mathexplorer.expresion.*;
import itcr.mathexplorer.funciones.*;

/**
 * @(#)Constante.java
 * 
 *Esta es una interface que define el cazcarón que debe tener cualquier constante
 *utilizada en el programa para que todas posean el método evaluar.
 *
 *@author Alexander Borbón Alpízar
 */
public class Constante implements Constantes{

	
	//CONSTRUCTORES
	/**
	 * Constructor sin parámetros para las constantes.
	 */
	public Constante(){ 	}

	/**
	 *Función que simplifica la expresión recibida. Si esta función se evalúa aquí quiere decir que no encontró el operador
	 *donde se tenía que evaluar, lo que es un error.
	 *@param expresionPrefijo La expresión a simplificar.
	 *@param funcionSimplificar La función que se encarga de simplificar. Se necesita para la recursividad.
	 *@param funcionSimplificarNumeros La función que se encarga de simplificar operaciones numéricas. Se necesita para la recursividad.
	 *@return El resultado de la operación con números.
	 *@exception ArithmeticException Se lanza si hay error al simplificar en la expresión.
	 */
	public Nodo simplificarNumeros(Nodo expresionPrefijo, Simplificar funcionSimplificar, SimplificarNumeros funcionSimplificarNumeros) throws ArithmeticException{
		throw new ArithmeticException("Error al simplificar la función");
	}
	
}//Fin de SintaxException