/**
 *@(#)Constantes.java
 *
 *Esta es una interface que define el cazcarón que debe tener cualquier constante
 *utilizada en el programa.
 *
 *@author Alexander Borbón Alpízar
 */

package itcr.mathexplorer.constantes;

import itcr.mathexplorer.expresion.*;
import itcr.mathexplorer.funciones.*;

/**
 *Esta es una interface que define el cazcarón que debe tener cualquier constante
 *utilizada en el programa para que todas posean el método evaluar.
 */
public interface Constantes{

	/**
	 *Función que simplifica la expresión recibida con números.
	 *@param expresionPrefijo La expresión a simplificar.
	 *@param funcionSimplificar La función que se encarga de simplificar. Se necesita para la recursividad.
	 *@param funcionSimplificarNumeros La función que se encarga de simplificar operaciones numéricas. Se necesita para la recursividad.
	 *@return El resultado de la operación con números.
	 *@exception ArithmeticException Se lanza si hay error al simplificar en la expresión.
	 */
	public Nodo simplificarNumeros(Nodo expresionPrefijo, Simplificar funcionSimplificar, SimplificarNumeros funcionSimplificarNumeros) throws ArithmeticException;

}//Fin de SintaxException