package itcr.mathexplorer.exceptions;

/**
 * @(#)NotFoundElementException.java
 *
 *Esta clase hereda la <code>ArrayIndexOutOfBoundsException</code> y define
 *la exception <code>NotFoundElementException</code> para cuando se presenta
 *un error en un Vector al buscar un elemento fuera del índice del tamaño
 *del vector.
 *
 * @author Alexander Borbón Alpízar
 */
public class NotFoundElementException extends ArrayIndexOutOfBoundsException {
	static final long serialVersionUID=10002;
	
    /**
     * Crea una nueva instancia de la exception <code>NotFoundElementException</code>.
     */
    public NotFoundElementException() {
    	super("No se encontró el elemento buscado");
    }
    
    /**
     * Construye una instancia de <code>NotFoundElementException</code> con el mensaje dado.
     *
     * @param message El mensaje que aparecerá en la exception.
     */
    public NotFoundElementException(String message) {
        super(message);
    }
}