package itcr.mathexplorer.exceptions;

/**
 *@(#)SintaxException.java
 *
 *Esta clase hereda la ArithmeticException y define
 *la exception SintaxException para cuando se presenta
 *un error de sintaxis en la escritura de la expresión
 *a traducir en postfijo.
 *
 *@author Alexander Borbón Alpízar
 */
public class SintaxException extends ArithmeticException{
	static final long serialVersionUID=10007;
	
	//CONSTRUCTORES

    /**
     * Crea una nueva instancia de la exception <code>ArithmeticException</code>.
     */
	public SintaxException(){
		super("Error de sintaxis en el polinomio");
	}
	
    /**
     * Construye una instancia de <code>ArithmeticException</code> con el mensaje dado.
     *
     * @param message El mensaje que aparecerá en la exception.
     */	
	public SintaxException(String message){
		super(message);
	}
}//Fin de SintaxException