package itcr.mathexplorer.herramientas;

import java.math.*;

/**
 * @(#)Punto2D.java
 * 
 *Clase para guardar un punto en dos dimensiones.
 *
 *@author Alexander Borbón Alpízar
 */

public class Punto2D{
	private BigDecimal x, y;
	
	/**
	 *Constructor que crea el punto a partir de números decimales grandes.
	 *@param a La coordenada x del punto.
	 *@param b La coordenada y del punto.
	 */
	public Punto2D(BigDecimal a, BigDecimal b){
		x=a;
		y=b;
	}
	
	/**
	 *Constructor que crea el punto a partir de números enteros.
	 *@param a La coordenada x del punto.
	 *@param b La coordenada y del punto.
	 */
	public Punto2D(float a, float b){
		x=new BigDecimal(a);
		y=new BigDecimal(b);
	}
	
	/**
	 *Constructor que crea el punto a partir de números enteros.
	 *@param a La coordenada x del punto.
	 *@param b La coordenada y del punto.
	 */
	public Punto2D(int a, int b){
		x=new BigDecimal(a);
		y=new BigDecimal(b);
	}
	
	/**
	 * Función que retorna la coordenada x del punto.
	 * @return Retorna la coordenada x del punto.
	 */
	public BigDecimal getX(){
		return x;
	}
	
	/**
	 * Función que retorna la coordenada y del punto.
	 * @return Retorna la coordenada y del punto.
	 */
	public BigDecimal getY(){
		return y;
	}
}