package itcr.mathexplorer.paneles;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;

/**
 *@(#)PanelDatos.java
 *
 *Este es el JDialog que se encarga de las opciones para
 *las funciones que necesitan obtener datos.
 *
 *@author Alexander Borbón Alpízar
 */
public class PanelDatos extends JDialog implements ActionListener{
	static final long serialVersionUID=10015;
	
	/**
	 * BTN_ACEPTAR se obtiene si se presiona el botón de aceptar.
	 */
	public final int BTN_ACEPTAR=2;
	/**
	 * BTN_EVALUAR se obtiene si se presiona el botón de evaluar.
	 */
	public final int BTN_EVALUAR=1;
	/**
	 * BTN_CANCELAR se obtiene si se presiona el botón de cancelar.
	 */
	public final int BTN_CANCELAR=0;
	
	private String dato1;
	private String dato2;
	private String dato3;
	private String dato4;
	private int boton, numDatos;
	
	JLabel label1, label2, label3, label4;
	JTextField txt1, txt2, txt3, txt4;
	JButton btnAceptar, btnEvaluar, btnCancelar;
	
	JPanel panelBotones, panelDatos;
	GridLayout layoutBotones, layoutDatos;
	
	/**
	 * Constructor por defecto que crea un JDialog para evaluar
	 * una expresión en un valor dado. Todos los campos se presentan vacíos.
	 */
	public PanelDatos(){
		numDatos=4;
		dato1="";
		dato2="";
		dato3="";
		dato4="";
		constructor("", "", "", "", "", dato1, dato2, dato3, dato4, numDatos);
	}
	
	/**
	 * Contructor que recibe las expresiones y los datos.
	 * @param Titulo El título de la ventana.
	 * @param Expresion1 El texto que se mostrará en la primera etiqueta.
	 * @param Dato1 El texto que se mostrará en el primer dato.
	 */
	public PanelDatos(String Titulo, String Expresion1, String Dato1){
		numDatos=1;
		dato1=Dato1;
		dato2="";
		dato3="";
		dato4="";
		constructor(Titulo, Expresion1, "", "", "", Dato1, "", "", "", numDatos);
	}
	
	/**
	 * Contructor que recibe las expresiones y los datos.
	 * @param Titulo El título de la ventana.
	 * @param Expresion1 El texto que se mostrará en la primera etiqueta.
	 * @param Expresion2 El texto que se mostrará en la segunda etiqueta.
	 * @param Dato1 El texto que se mostrará en el primer dato.
	 * @param Dato2 El texto que se mostrará en el segundo dato.
	 */
	public PanelDatos(String Titulo, String Expresion1, String Expresion2, String Dato1, String Dato2){
		numDatos=2;
		dato1=Dato1;
		dato2=Dato2;
		dato3="";
		dato4="";
		constructor(Titulo, Expresion1, Expresion2, "", "", Dato1, Dato2, "", "", numDatos);
	}
	
	/**
	 * Contructor que recibe las expresiones y los datos. 
	 * @param Titulo El título de la ventana.
	 * @param Expresion1 El texto que se mostrará en la primera etiqueta.
	 * @param Expresion2 El texto que se mostrará en la segunda etiqueta.
	 * @param Expresion3 El texto que se mostrará en la tercera etiqueta.
	 * @param Dato1 El texto que se mostrará en el primer dato.
	 * @param Dato2 El texto que se mostrará en el segundo dato.
	 * @param Dato3 El texto que se mostrará en el tercer dato.
	 */
	public PanelDatos(String Titulo, String Expresion1, String Expresion2, String Expresion3, String Dato1, String Dato2, String Dato3){
		numDatos=3;
		dato1=Dato1;
		dato2=Dato2;
		dato3=Dato3;
		dato4="";
		constructor(Titulo, Expresion1, Expresion2, Expresion3, "", Dato1, Dato2, Dato3, "", numDatos);
	}
	
	/**
	 * Contructor que recibe las expresiones y los datos. 
	 * @param Titulo El título de la ventana.
	 * @param Expresion1 El texto que se mostrará en la primera etiqueta.
	 * @param Expresion2 El texto que se mostrará en la segunda etiqueta.
	 * @param Expresion3 El texto que se mostrará en la tercera etiqueta.
	 * @param Expresion4 El texto que se mostrará en la cuarta etiqueta.
	 * @param Dato1 El texto que se mostrará en el primer dato.
	 * @param Dato2 El texto que se mostrará en el segundo dato.
	 * @param Dato3 El texto que se mostrará en el tercer dato.
	 * @param Dato4 El texto que se mostrará en el cuarto dato.
	 */
	public PanelDatos(String Titulo, String Expresion1, String Expresion2, String Expresion3, String Expresion4, String Dato1, String Dato2, String Dato3, String Dato4){
		numDatos=4;
		dato1=Dato1;
		dato2=Dato2;
		dato3=Dato3;
		dato4=Dato4;
		constructor(Titulo, Expresion1, Expresion2, Expresion3, Expresion4, Dato1, Dato2, Dato3, Dato4, numDatos);
	}
	
	private void constructor(String Titulo, String Expresion1, String Expresion2, String Expresion3, String Expresion4, String Dato1, String Dato2, String Dato3, String Dato4, int NumDatos){
		this.setTitle(Titulo);
		this.pack();
		this.setSize(350, 250);
		this.setLocationRelativeTo(null);
		this.setModal(true);
		
		boton=0;
		
		label1=new JLabel(Expresion1);
		label2=new JLabel(Expresion2);
		label3=new JLabel(Expresion3);
		label4=new JLabel(Expresion4);
		
		txt1=new JTextField(Dato1);
		txt1.addActionListener(this);
		txt2=new JTextField(Dato2);
		txt2.addActionListener(this);
		txt3=new JTextField(Dato3);
		txt3.addActionListener(this);
		txt4=new JTextField(Dato4);
		txt4.addActionListener(this);
		
		btnAceptar=new JButton("Aceptar");
		btnAceptar.addActionListener(this);
		btnEvaluar=new JButton("Evaluar");
		btnEvaluar.addActionListener(this);
		btnCancelar=new JButton("Cancelar");
		btnCancelar.addActionListener(this);
		
		layoutBotones=new GridLayout(1,3,10,10);
		panelBotones=new JPanel();
		panelBotones.setBorder(new EmptyBorder(20,20,20,20));
		panelBotones.setLayout(layoutBotones);
		panelBotones.add(btnAceptar);
		panelBotones.add(btnEvaluar);
		panelBotones.add(btnCancelar);
		
		layoutDatos=new GridLayout(NumDatos,2,20,20);
		panelDatos=new JPanel();
		panelDatos.setBorder(new EmptyBorder(20*(4-numDatos)+10,20,20*(4-numDatos),20));//+20*(3-numDatos)
		panelDatos.setLayout(layoutDatos);
		panelDatos.add(label1);
		panelDatos.add(txt1);
		if(NumDatos>1){
			panelDatos.add(label2);
			panelDatos.add(txt2);
			if(NumDatos>2){
				panelDatos.add(label3);
				panelDatos.add(txt3);
				if(NumDatos>3){
					panelDatos.add(label4);
					panelDatos.add(txt4);
				}
			}
		}
		
		this.add(panelDatos, BorderLayout.CENTER);
		this.add(panelBotones, BorderLayout.SOUTH);
		
		this.setVisible(true);
	}
	
	public void actionPerformed( ActionEvent evt ) {
		if(evt.getSource()==btnAceptar){
			dato1=txt1.getText();
			dato2=txt2.getText();
			dato3=txt3.getText();
			dato4=txt4.getText();
			if(dato1.equals("") || (dato2.equals("") && numDatos>1) || (dato3.equals("") && numDatos>2) || (dato4.equals("") && numDatos>3)){
				JOptionPane.showMessageDialog(this,"Alguno de los datos no se ha llenado.","Error",JOptionPane.ERROR_MESSAGE);
			}else{
				boton=BTN_ACEPTAR;
				this.dispose();
			}
		}else if(evt.getSource()==btnEvaluar){
			dato1=txt1.getText();
			dato2=txt2.getText();
			dato3=txt3.getText();
			dato4=txt4.getText();
			if(dato1.equals("") || (dato2.equals("") && numDatos>1) || (dato3.equals("") && numDatos>2) || (dato4.equals("") && numDatos>3)){
				JOptionPane.showMessageDialog(this,"Alguno de los datos no se ha llenado.","Error",JOptionPane.ERROR_MESSAGE);
			}else{
				boton=BTN_EVALUAR;
				this.dispose();
			}
		}else if(evt.getSource()==btnCancelar){
			boton=BTN_CANCELAR;
			this.dispose();
		}
	}
	
	/**
	 * Devuelve el botón que se presionó al salir.
	 * @return El botón presionado.
	 */
	public int getBoton(){
		return boton;
	}
	
	/**
	 * Devuelve El primer dato.
	 * @return El primer dato.
	 */
	public String getDato1(){
		return dato1;
	}
	
	/**
	 * Devuelve El segundo dato.
	 * @return El segundo dato.
	 */
	public String getDato2(){
		return dato2;
	}
	
	/**
	 * Devuelve El tercer dato.
	 * @return El tercer dato.
	 */
	public String getDato3(){
		return dato3;
	}
	
	/**
	 * Devuelve El cuarto dato.
	 * @return El cuarto dato.
	 */
	public String getDato4(){
		return dato4;
	}
}