package itcr.mathexplorer.paneles;

import java.awt.*;
import javax.swing.*;
import java.util.*;
import itcr.mathexplorer.traductores.*;
import itcr.mathexplorer.expresion.*;
import itcr.mathexplorer.exceptions.*;
import itcr.mathexplorer.herramientas.Opciones;

/**
 *@(#)PanelExpresiones.java
 *
 *Este es el panel donde se colocan todas las expresiones.
 *
 *@author Alexander Borbón Alpízar
 */
public class PanelExpresiones extends JPanel{
	static final long serialVersionUID=10003;

	//VARIABLES GLOBALES
	
	//private Vector expresiones;
	
	
	private GridBagLayout milayout;
	private GridBagConstraints c;
	
	private TraductorPrefijoImagen expresionImagenAnterior;
	private JLabel etiquetaAnterior;
	
	//CONSTRUCTORES
	/**
	 * Constructor vacío para el Panel de Expresiones.
	 */
	public PanelExpresiones(){
		super();
		milayout=new GridBagLayout();
		c = new GridBagConstraints();
		this.setLayout(milayout);
		//expresiones=new Vector();
	}
	
	/**
	 * Constructor del Panel de Expresiones que recibe las expresiones a mostrar.
	 * @param Expresiones Las expresiones que se deben poner en el paenl.
	 */
	public PanelExpresiones(Vector Expresiones){
		super();
		milayout=new GridBagLayout();
		c = new GridBagConstraints();
		this.setLayout(milayout);
		JLabel etiqueta;
		TraductorPrefijoImagen expresionImagen;
		Font letra=Opciones.getTipoLetra();
		letra=new Font(letra.getName(), Font.ITALIC+Font.BOLD, letra.getSize()+1);
		int i;
		
		//try{
		
			for(i=0; i<Expresiones.size()-2; i++){
				if(i%2==0){
					etiqueta=new JLabel(" Exp: ");
				}else{
					etiqueta=new JLabel("    Sol: ");
				}
				
				etiqueta.setForeground(Opciones.getColorLetra());
				etiqueta.setFont(letra);
				
				c.gridwidth = 1;
				c.gridheight = 1;
				c.weightx = 0;
				c.weighty = 0;
				c.anchor=GridBagConstraints.WEST;
				milayout.setConstraints(etiqueta, c);
				this.add(etiqueta);
				
				expresionImagen=((Expresion)Expresiones.elementAt(i)).obtenExpresionImagen();
				c.gridwidth = GridBagConstraints.REMAINDER;
				c.gridheight = 1;
				c.weightx = 1;
				c.weighty = 0;
				c.anchor=GridBagConstraints.WEST;
				milayout.setConstraints(expresionImagen, c);
				this.add(expresionImagen);
				
				i++;
			}
			
			if(i%2==0){
				etiqueta=new JLabel(" Exp: ");
			}else{
				etiqueta=new JLabel("    Sol: ");
			}
			etiqueta.setForeground(Opciones.getColorLetra());
			etiqueta.setFont(letra);
			
			c.gridwidth = 1;
			c.weightx = 0;
			c.weighty = 1;
			c.anchor=GridBagConstraints.NORTHWEST;
			c.gridheight = GridBagConstraints.REMAINDER;
			milayout.setConstraints(etiqueta, c);
			this.add(etiqueta);
			
			expresionImagen=((Expresion)Expresiones.elementAt(i)).obtenExpresionImagen();
			//expresiones.add(expresionImagen);
			c.gridwidth = GridBagConstraints.REMAINDER;
			c.gridheight = GridBagConstraints.REMAINDER;
			c.weightx = 1;
			c.weighty = 1;
			c.anchor=GridBagConstraints.NORTHWEST;
			milayout.setConstraints(expresionImagen, c);
			this.add(expresionImagen);
	
			etiquetaAnterior=etiqueta;
			expresionImagenAnterior=expresionImagen;
		/*}catch(Exception e){
			e.printStackTrace();
			throw new SintaxException("Error al agregar expresiones al panel");
		}*/
	}
	
	//FUNCIONES PUBLICAS
	
	/**
	 *Esta función cambia la expresión representada en este JPanel
	 *@param expresionImagen La imagen de la expresión que debe colocar en el JPanel.
	 *@param mensaje El mensaje que se debe anteponer a la imagen.
	 *@exception SintaxException Error en la expresión.
	 */
	public void agregaExpresion(TraductorPrefijoImagen expresionImagen, String mensaje) throws SintaxException{
		try{
			Font letra=Opciones.getTipoLetra();
			letra=new Font(letra.getName(), Font.ITALIC+Font.BOLD, letra.getSize()+1);

			if(etiquetaAnterior!=null && expresionImagenAnterior!=null){
				c.gridwidth = 1;
				c.gridheight = 1;
				c.weightx = 0;
				c.weighty = 0;
				c.anchor=GridBagConstraints.WEST;
				milayout.setConstraints(etiquetaAnterior, c);
				
				c.gridwidth = GridBagConstraints.REMAINDER;
				c.gridheight = 1;
				c.weightx = 1;
				c.weighty = 0;
				c.anchor=GridBagConstraints.WEST;
				milayout.setConstraints(expresionImagenAnterior, c);
			}
			
			c.gridwidth = 1;
			c.weightx = 0;
			c.weighty = 1;
			c.anchor=GridBagConstraints.NORTHWEST;
			c.gridheight = GridBagConstraints.REMAINDER;
			JLabel etiqueta=new JLabel(mensaje);
			etiqueta.setForeground(Opciones.getColorLetra());
			etiqueta.setFont(letra);
			
			milayout.setConstraints(etiqueta, c);
			this.add(etiqueta);
			
			c.gridwidth = GridBagConstraints.REMAINDER;
			c.gridheight = GridBagConstraints.REMAINDER;
			c.weightx = 1;
			c.weighty = 1;
			c.anchor=GridBagConstraints.NORTHWEST;
			milayout.setConstraints(expresionImagen, c);
			this.add(expresionImagen);
			
			etiquetaAnterior=etiqueta;
			expresionImagenAnterior=expresionImagen;
		}catch(Exception e){
			e.printStackTrace();
			throw new SintaxException("Error al agregar otra expresion al panel");
		}
	}
	
	/**
	 *Define el color de la letra para las expresiones de este panel.
	 *@param bg El nuevo color de la letra.
	 */
	public void setColorLetra(Color bg){
		Component componentes[]=this.getComponents();
		for(int i=0; i<componentes.length-1;i=i+2){
			((JLabel)componentes[i]).setForeground(bg);
			((TraductorPrefijoImagen)componentes[i+1]).pintarImagen(true);
			((TraductorPrefijoImagen)componentes[i+1]).repaint();
		}
	}
	
	/**
	 *Define el tipo de la letra para las expresiones de este panel.
	 *@param tipoLetra El nuevo tipo de letra.
	 */
	public void setTipoLetra(Font tipoLetra){
		Component componentes[]=this.getComponents();
		for(int i=0; i<componentes.length-1;i=i+2){
			((JLabel)componentes[i]).setFont(tipoLetra);
			((TraductorPrefijoImagen)componentes[i+1]).pintarImagen(true);
			((TraductorPrefijoImagen)componentes[i+1]).repaint();
		}
		this.repaint();
	}
	
	/**
	 *Define el color del fondo para el panel y las expresiones.
	 *@param bg El nuevo color del fondo.
	 */
	public void setColorFondo(Color bg){
		Component componentes[]=this.getComponents();
		for(int i=0; i<componentes.length-1;i=i+2){
			((JLabel)componentes[i]).setBackground(bg);
			((TraductorPrefijoImagen)componentes[i+1]).pintarImagen(true);
			((TraductorPrefijoImagen)componentes[i+1]).repaint();
		}
		this.setBackground(bg);
	}

	
}//fin de PanelExpresiones