package itcr.mathexplorer.paneles;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import itcr.mathexplorer.herramientas.Opciones;
import itcr.mathexplorer.tablas.*;
import itcr.mathexplorer.expresion.*;

/**
 *@(#)PanelOpciones.java
 *
 *Este es el JDialog que se encarga de las opciones del programa.
 *
 *@author Alexander Borbón Alpízar
 */
public class PanelOpciones extends JDialog implements ActionListener, ChangeListener{
	static final long serialVersionUID=10005;
	
	JButton botonAceptar, botonCancelar, botonPredeterminado;
	
	JTabbedPane pestanaPanel;
	JPanel panelBotones, panelMatematicas, panelMatematicas1, panelMatematicas2, 
		panelApariencia, panelVistaPrevia, panelGraficos, panelGraficos1, panelGraficos2, panelGraficos3, panelGraficos4,
		panelGraficosAvanzados, panelGraficos3D, panelGraficos13D, panelGraficos23D, panelGraficos33D, panelGraficos43D,
		panelGraficosAvanzados3D;
	PanelGraficos2D panelMuestra;
	PanelGraficos3D panelMuestra3D;
	JButton cambiar1, cambiar2, cambiar3, cambiarGraficos1, cambiarGraficos2, cambiarGraficos3, 
		cambiarGraficos4, cambiarGraficos5, cambiarGraficos13D, cambiarGraficos23D, cambiarGraficos33D, 
		cambiarGraficos43D, cambiarGraficos53D;
	JLabel labelPrecision, labelDecimales, labelApariencia, labelColorLetra, labelTipoLetra,
		labelColorFondo, labelAngulos, vistaPrevia, labelColorFondoGraficas, labelColorEjes, 
		labelColorEjesAtenuados, labelColorGrafica, labelLetraEjes, labelCantidadPuntos,
		labelpixelesMarcasX, labelpixelesMarcasY, labelColorFondoGraficas3D, labelColorEjes3D, 
		labelColorEjesAtenuados3D, labelColorGrafica3D, labelLetraEjes3D, labelCantidadPuntos3D,
		labelpixelesMarcasX3D, labelpixelesMarcasY3D, labelpixelesMarcasZ3D;
	JRadioButton radioExacta, radioAproximada, radioRadianes, radioGrados, radioColorAlternar, radioColorFijo,
		radioColorAlternar3D, radioColorFijo3D;
	ButtonGroup grupoPresicion, grupoAngulos, grupoColorGrafica, grupoColorGrafica3D;
	JSpinner spinnerDecimales, spinnerPuntos, spinnerPixelesMarcasX, spinnerPixelesMarcasY,
		spinnerPuntos3D, spinnerPixelesMarcasX3D, spinnerPixelesMarcasY3D, spinnerPixelesMarcasZ3D;
	JComboBox comboApariencia;
	
	private String aspecto;
	private boolean exacta, radianes, alternar, alternar3D;
	private int decimales, numPuntos, pixelesMarcasX, pixelesMarcasY, numPuntos3D, pixelesMarcasX3D, pixelesMarcasY3D, pixelesMarcasZ3D;
	private Color colorLetra, colorFondo, colorFondoGrafica, colorEjesGrafica, colorEjesAtenuadosGrafica, colorFijo,
		colorFondoGrafica3D, colorEjesGrafica3D, colorEjesAtenuadosGrafica3D, colorFijo3D;
	private Font tipoLetra, tipoLetraEjes, tipoLetraEjes3D;
	
	GridBagLayout layoutMatematicas1, layoutMatematicas2, layoutApariencia, layoutGraficos, layoutGraficos2, layoutGraficosAvanzados,
		layoutGraficos3D, layoutGraficos23D, layoutGraficosAvanzados3D;
	GridBagConstraints c;
	
	JDialog estaJDialog;
	
	/**
	 * Constructor de la ventana de diálogo para las opciones del programa.
	 * @param tablaOperadores Tabla con todos los operadores del programa.
	 * @param tablaFunciones Tabla con todas las funciones del programa.
	 * @param tablaConstantes Tabla con todas las constantes del programa.
	 * @param tablaFuncionesUsuario Tabla con todas las funciones definidas por el usuario en el programa.
	 */
	public PanelOpciones(TablaOperadores tablaOperadores, TablaFunciones tablaFunciones, TablaConstantes tablaConstantes, TablaFuncionesUsuario tablaFuncionesUsuario){
		this.setTitle("Opciones");
		this.pack();
		this.setSize(450, 400);
		this.setLocationRelativeTo(null);
		this.setLayout(new BorderLayout());
		estaJDialog=this;
		this.setModal(true);
		
		//SE CONSTRUYE EL PANEL PARA LAS OPCIONES MATEMATICAS
		
		labelPrecision=new JLabel("Precisión:  ");
		labelDecimales=new JLabel("Número de Decimales:  ");
		radioExacta=new JRadioButton("Exacta");
		radioAproximada=new JRadioButton("Aproximada");
		grupoPresicion=new ButtonGroup();
		
		radioExacta.addActionListener(this);
		radioAproximada.addActionListener(this);
		
		grupoPresicion.add(radioExacta);
		grupoPresicion.add(radioAproximada);
		
		spinnerDecimales=new JSpinner();
		decimales=Opciones.getNumDecimales()-10;
		spinnerDecimales.setValue(decimales);
		spinnerDecimales.addChangeListener(this);

		if(Opciones.getPresicion()){
			radioExacta.setSelected(true);
			spinnerDecimales.setEnabled(false);
			exacta=true;
		}else{
			radioAproximada.setSelected(true);
			spinnerDecimales.setEnabled(true);
			exacta=false;
		}
		
		labelAngulos=new JLabel("ángulos:  ");
		radioRadianes=new JRadioButton("Radianes");
		radioGrados=new JRadioButton("Grados");
		grupoAngulos=new ButtonGroup();
		
		radioRadianes.addActionListener(this);
		radioGrados.addActionListener(this);
		
		grupoAngulos.add(radioRadianes);
		grupoAngulos.add(radioGrados);
		
		if(Opciones.getAngulo()){
			radioRadianes.setSelected(true);
			radianes=true;
		}else{
			radioGrados.setSelected(true);
			radianes=false;
		}
		
		layoutMatematicas1=new GridBagLayout();
		layoutMatematicas2=new GridBagLayout();
		panelMatematicas=new JPanel(new GridLayout(2,1));
		panelMatematicas1=new JPanel(layoutMatematicas1);
		panelMatematicas2=new JPanel(layoutMatematicas2);
		panelMatematicas.setBorder(new EmptyBorder(5,5,5,5));
		panelMatematicas1.setBorder(new EmptyBorder(5,5,5,5));
		panelMatematicas2.setBorder(new EmptyBorder(5,5,5,5));
		c = new GridBagConstraints();
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.anchor=GridBagConstraints.WEST;
		layoutMatematicas1.setConstraints(labelPrecision, c);
		
		c.gridwidth = 1;
		c.anchor=GridBagConstraints.CENTER;
		c.weightx = 1;
		c.weighty = 1;
		layoutMatematicas1.setConstraints(radioExacta, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutMatematicas1.setConstraints(radioAproximada, c);
		
		c.gridwidth = 1;
		c.anchor=GridBagConstraints.EAST;
		layoutMatematicas1.setConstraints(labelDecimales, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.anchor=GridBagConstraints.CENTER;
		layoutMatematicas1.setConstraints(spinnerDecimales, c);
		
		panelMatematicas1.add(labelPrecision);
		panelMatematicas1.add(radioExacta);
		panelMatematicas1.add(radioAproximada);
		panelMatematicas1.add(labelDecimales);
		panelMatematicas1.add(spinnerDecimales);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.anchor=GridBagConstraints.WEST;
		layoutMatematicas2.setConstraints(labelAngulos, c);
		
		c.gridwidth = 1;
		c.anchor=GridBagConstraints.CENTER;
		layoutMatematicas2.setConstraints(radioRadianes, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutMatematicas2.setConstraints(radioGrados, c);
		
		panelMatematicas2.add(labelAngulos);
		panelMatematicas2.add(radioRadianes);
		panelMatematicas2.add(radioGrados);
		
		panelMatematicas.add(panelMatematicas1);
		panelMatematicas.add(panelMatematicas2);
		
		//SE CONSTRUYE EL PANEL PARA LAS OPCIONES DE APARIENCIA
		
		labelApariencia=new JLabel("Apariencia: ");
		labelColorLetra=new JLabel("Color de Letra: ");
		labelColorFondo=new JLabel("Color de Fondo: ");
		labelTipoLetra=new JLabel("Tipo de Letra: ");
		
		cambiar1=new JButton("Cambiar...");
		cambiar1.addActionListener(this);
		
		cambiar2=new JButton("Cambiar...");
		cambiar2.addActionListener(this);
		
		cambiar3=new JButton("Cambiar...");
		cambiar3.addActionListener(this);
		
		comboApariencia=new JComboBox();
		comboApariencia.addItem("Metal");
		comboApariencia.addItem("Native");
		comboApariencia.addItem("Motif");
		comboApariencia.addActionListener(this);
		comboApariencia.setSelectedItem(Opciones.getAspecto());
		
		panelVistaPrevia = new JPanel();
		TitledBorder titledborder = BorderFactory.createTitledBorder("Vista previa:");
		panelVistaPrevia.setBorder(titledborder);
		panelVistaPrevia.setLayout(new BorderLayout());
		panelVistaPrevia.setPreferredSize(new Dimension(415,75));
		panelVistaPrevia.setBackground(Opciones.getColorFondo());
		panelVistaPrevia.add(new JLabel("_________      "), BorderLayout.WEST);
		vistaPrevia = new JLabel("Vista Previa");
		vistaPrevia.setHorizontalAlignment(SwingConstants.CENTER);
		//vistaPrevia.setBackground(Opciones.getColorFondo());
		vistaPrevia.setForeground(Opciones.getColorLetra());
		vistaPrevia.setFont(Opciones.getTipoLetra());
		panelVistaPrevia.add(vistaPrevia, BorderLayout.CENTER);
		panelVistaPrevia.add(new JLabel("      _________"), BorderLayout.EAST);
		
		layoutApariencia=new GridBagLayout();
		panelApariencia=new JPanel(layoutApariencia);
		panelApariencia.setBorder(new EmptyBorder(10,10,10,10));
		
		c.gridwidth = 1;
		c.weightx = 0;
		c.weighty = 0;
		layoutApariencia.setConstraints(labelApariencia, c);
		panelApariencia.add(labelApariencia);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutApariencia.setConstraints(comboApariencia, c);
		panelApariencia.add(comboApariencia);
		
		c.gridwidth = 1;
		c.weightx = 1;
		c.weighty = 1;
		layoutApariencia.setConstraints(labelColorFondo, c);
		panelApariencia.add(labelColorFondo);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutApariencia.setConstraints(cambiar1, c);
		panelApariencia.add(cambiar1);
		
		c.gridwidth = 1;
		layoutApariencia.setConstraints(labelColorLetra, c);
		panelApariencia.add(labelColorLetra);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutApariencia.setConstraints(cambiar2, c);
		panelApariencia.add(cambiar2);
		
		c.gridwidth = 1;
		layoutApariencia.setConstraints(labelTipoLetra, c);
		panelApariencia.add(labelTipoLetra);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutApariencia.setConstraints(cambiar3, c);
		panelApariencia.add(cambiar3);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutApariencia.setConstraints(panelVistaPrevia, c);
		panelApariencia.add(panelVistaPrevia);
		
		//SE CONSTRUYE EL PANEL PARA LAS OPCIONES GRÁFICAS
		
		labelColorFondoGraficas=new JLabel("Color del fondo: ");
		labelColorEjes=new JLabel("Color de los ejes: ");
		labelColorEjesAtenuados=new JLabel("Color de los ejes atenuados: ");
		labelColorGrafica=new JLabel("                          Color de la gráfica: ");
		labelLetraEjes=new JLabel("Letra de los ejes: ");
		labelCantidadPuntos=new JLabel("Calidad de la gráfica (1 es la mejor): ");
		
		cambiarGraficos1=new JButton("Cambiar...");
		cambiarGraficos1.addActionListener(this);
		
		cambiarGraficos2=new JButton("Cambiar...");
		cambiarGraficos2.addActionListener(this);
		
		cambiarGraficos3=new JButton("Cambiar...");
		cambiarGraficos3.addActionListener(this);
		
		cambiarGraficos4=new JButton("Cambiar...");
		cambiarGraficos4.addActionListener(this);
		
		cambiarGraficos5=new JButton("Cambiar...");
		cambiarGraficos5.addActionListener(this);
		
		radioColorAlternar=new JRadioButton("Alternar");
		radioColorAlternar.addActionListener(this);
		radioColorFijo=new JRadioButton("Color Fijo            ");
		radioColorFijo.addActionListener(this);
		
		if(Opciones.getAlternarColorGrafica()){
			radioColorAlternar.setSelected(true);
			cambiarGraficos4.setEnabled(false);
			alternar=true;
		}else{
			radioColorFijo.setSelected(true);
			cambiarGraficos4.setEnabled(true);
			alternar=false;
		}
		
		grupoColorGrafica=new ButtonGroup();
		grupoColorGrafica.add(radioColorAlternar);
		grupoColorGrafica.add(radioColorFijo);
		
		numPuntos=Opciones.getNumPuntosGrafica();
		SpinnerModel model =new SpinnerNumberModel(numPuntos, 1, 100, 1);

		spinnerPuntos=new JSpinner(model);
		spinnerPuntos.addChangeListener(this);
		
		Nodo comodin=new Nodo("x");
		Nodo comodin2=new Nodo("Variable");
		comodin2.agregaOperando(comodin);
		comodin=new Nodo("sen");
		comodin.agregaOperando(comodin2);
		
		panelMuestra=new PanelGraficos2D(comodin,-5,5,-2,2,tablaOperadores, tablaFunciones, tablaConstantes, tablaFuncionesUsuario);
		panelMuestra.setBorder(titledborder);
		panelMuestra.setPreferredSize(new Dimension(415,75));
		
		layoutGraficos=new GridBagLayout();
		layoutGraficos2=new GridBagLayout();
		
		panelGraficos2=new JPanel(layoutGraficos2);
		panelGraficos2.setBorder(new EmptyBorder(3,3,3,3));
		
		panelGraficos=new JPanel(layoutGraficos);
		panelGraficos.setBorder(new EmptyBorder(5,5,5,5));
		
		c.gridwidth = 1;
		layoutGraficos.setConstraints(labelColorFondoGraficas, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutGraficos.setConstraints(cambiarGraficos1, c);
		
		c.gridwidth = 1;
		layoutGraficos.setConstraints(labelColorEjes, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutGraficos.setConstraints(cambiarGraficos2, c);
		
		c.gridwidth = 1;
		layoutGraficos.setConstraints(labelColorEjesAtenuados, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutGraficos.setConstraints(cambiarGraficos3, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.anchor = GridBagConstraints.WEST;
		layoutGraficos.setConstraints(labelColorGrafica, c);
		
		panelGraficos.add(labelColorFondoGraficas);
		panelGraficos.add(cambiarGraficos1);
		panelGraficos.add(labelColorEjes);
		panelGraficos.add(cambiarGraficos2);
		panelGraficos.add(labelColorEjesAtenuados);
		panelGraficos.add(cambiarGraficos3);
		panelGraficos.add(labelColorGrafica);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.anchor=GridBagConstraints.WEST;
		layoutGraficos2.setConstraints(radioColorAlternar, c);
		
		c.gridwidth = 1;
		layoutGraficos2.setConstraints(radioColorFijo, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.anchor=GridBagConstraints.CENTER;
		layoutGraficos2.setConstraints(cambiarGraficos4, c);
		
		panelGraficos2.add(radioColorAlternar);
		panelGraficos2.add(radioColorFijo);
		panelGraficos2.add(cambiarGraficos4);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.anchor=GridBagConstraints.CENTER;
		layoutGraficos.setConstraints(panelGraficos2, c);
		
		panelGraficos.add(panelGraficos2);
		
		c.gridwidth = 1;
		layoutGraficos.setConstraints(labelLetraEjes, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutGraficos.setConstraints(cambiarGraficos5, c);
		
		panelGraficos.add(labelLetraEjes);
		panelGraficos.add(cambiarGraficos5);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutGraficos.setConstraints(panelMuestra, c);
		
		panelGraficos.add(panelMuestra);
		
		//SE CONSTRUYE EL PANEL PARA LAS OPCIONES GRÁFICAS AVANZADOS
		
		labelpixelesMarcasX=new JLabel("Pixeles a los que se pone cada marca en el eje X");
		labelpixelesMarcasY=new JLabel("Pixeles a los que se pone cada marca en el eje Y");
		
		pixelesMarcasX=Opciones.getPixelesMarcasX();
		pixelesMarcasY=Opciones.getPixelesMarcasY();
		
		SpinnerNumberModel model1=new SpinnerNumberModel(pixelesMarcasX, 1, 500, 1);
		spinnerPixelesMarcasX=new JSpinner(model1);
		spinnerPixelesMarcasX.addChangeListener(this);

		SpinnerNumberModel model2=new SpinnerNumberModel(pixelesMarcasY, 1, 500, 1);
		spinnerPixelesMarcasY=new JSpinner(model2);
		spinnerPixelesMarcasY.addChangeListener(this);
		
		layoutGraficosAvanzados=new GridBagLayout();
		
		panelGraficosAvanzados=new JPanel(layoutGraficosAvanzados);
		panelGraficosAvanzados.setBorder(new EmptyBorder(5,5,5,5));
		
		c.gridwidth = 1;
		layoutGraficosAvanzados.setConstraints(labelCantidadPuntos, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutGraficosAvanzados.setConstraints(spinnerPuntos, c);
		
		c.gridwidth = 1;
		layoutGraficosAvanzados.setConstraints(labelpixelesMarcasX, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutGraficosAvanzados.setConstraints(spinnerPixelesMarcasX, c);
		
		c.gridwidth = 1;
		layoutGraficosAvanzados.setConstraints(labelpixelesMarcasY, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutGraficosAvanzados.setConstraints(spinnerPixelesMarcasY, c);
		
		panelGraficosAvanzados.add(labelCantidadPuntos);
		panelGraficosAvanzados.add(spinnerPuntos);
		panelGraficosAvanzados.add(labelpixelesMarcasX);
		panelGraficosAvanzados.add(spinnerPixelesMarcasX);
		panelGraficosAvanzados.add(labelpixelesMarcasY);
		panelGraficosAvanzados.add(spinnerPixelesMarcasY);
		
		//SE CONSTRUYE EL PANEL PARA LAS OPCIONES GRÁFICAS EN 3D
		
		labelColorFondoGraficas3D=new JLabel("Color del fondo: ");
		labelColorEjes3D=new JLabel("Color de los ejes: ");
		labelColorEjesAtenuados3D=new JLabel("Color de los ejes atenuados: ");
		labelColorGrafica3D=new JLabel("                          Color de la gráfica: ");
		labelLetraEjes3D=new JLabel("Letra de los ejes: ");
		labelCantidadPuntos3D=new JLabel("Calidad de la gráfica (1 es la mejor): ");
		
		cambiarGraficos13D=new JButton("Cambiar...");
		cambiarGraficos13D.addActionListener(this);
		
		cambiarGraficos23D=new JButton("Cambiar...");
		cambiarGraficos23D.addActionListener(this);
		
		cambiarGraficos33D=new JButton("Cambiar...");
		cambiarGraficos33D.addActionListener(this);
		
		cambiarGraficos43D=new JButton("Cambiar...");
		cambiarGraficos43D.addActionListener(this);
		
		cambiarGraficos53D=new JButton("Cambiar...");
		cambiarGraficos53D.addActionListener(this);
		
		radioColorAlternar3D=new JRadioButton("Alternar");
		radioColorAlternar3D.addActionListener(this);
		radioColorFijo3D=new JRadioButton("Color Fijo            ");
		radioColorFijo3D.addActionListener(this);
		
		if(Opciones.getAlternarColorGrafica3D()){
			radioColorAlternar3D.setSelected(true);
			cambiarGraficos43D.setEnabled(false);
			alternar3D=true;
		}else{
			radioColorFijo3D.setSelected(true);
			cambiarGraficos43D.setEnabled(true);
			alternar3D=false;
		}
		
		grupoColorGrafica3D=new ButtonGroup();
		grupoColorGrafica3D.add(radioColorAlternar3D);
		grupoColorGrafica3D.add(radioColorFijo3D);
		
		numPuntos3D=Opciones.getNumPuntosGrafica3D();
		SpinnerModel model3D =new SpinnerNumberModel(numPuntos3D, 1, 100, 1);

		spinnerPuntos3D=new JSpinner(model3D);
		spinnerPuntos3D.addChangeListener(this);
		
		comodin=new Nodo("y");
		comodin2=new Nodo("Variable");
		comodin2.agregaOperando(comodin);
		comodin=new Nodo("sen");
		comodin.agregaOperando(comodin2);
		
		panelMuestra3D=new PanelGraficos3D(comodin,-2,2,-5,5,-2,2,tablaOperadores, tablaFunciones, tablaConstantes, tablaFuncionesUsuario);
		panelMuestra3D.setBorder(titledborder);
		panelMuestra3D.setPreferredSize(new Dimension(415,75));
		
		layoutGraficos3D=new GridBagLayout();
		layoutGraficos23D=new GridBagLayout();
		
		panelGraficos23D=new JPanel(layoutGraficos23D);
		panelGraficos23D.setBorder(new EmptyBorder(3,3,3,3));
		
		panelGraficos3D=new JPanel(layoutGraficos3D);
		panelGraficos3D.setBorder(new EmptyBorder(5,5,5,5));
		
		c.gridwidth = 1;
		layoutGraficos3D.setConstraints(labelColorFondoGraficas3D, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutGraficos3D.setConstraints(cambiarGraficos13D, c);
		
		c.gridwidth = 1;
		layoutGraficos3D.setConstraints(labelColorEjes3D, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutGraficos3D.setConstraints(cambiarGraficos23D, c);
		
		c.gridwidth = 1;
		layoutGraficos3D.setConstraints(labelColorEjesAtenuados3D, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutGraficos3D.setConstraints(cambiarGraficos33D, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.anchor = GridBagConstraints.WEST;
		layoutGraficos3D.setConstraints(labelColorGrafica3D, c);
		
		panelGraficos3D.add(labelColorFondoGraficas3D);
		panelGraficos3D.add(cambiarGraficos13D);
		panelGraficos3D.add(labelColorEjes3D);
		panelGraficos3D.add(cambiarGraficos23D);
		panelGraficos3D.add(labelColorEjesAtenuados3D);
		panelGraficos3D.add(cambiarGraficos33D);
		panelGraficos3D.add(labelColorGrafica3D);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.anchor=GridBagConstraints.WEST;
		layoutGraficos23D.setConstraints(radioColorAlternar3D, c);
		
		c.gridwidth = 1;
		layoutGraficos23D.setConstraints(radioColorFijo3D, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.anchor=GridBagConstraints.CENTER;
		layoutGraficos23D.setConstraints(cambiarGraficos43D, c);
		
		panelGraficos23D.add(radioColorAlternar3D);
		panelGraficos23D.add(radioColorFijo3D);
		panelGraficos23D.add(cambiarGraficos43D);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.anchor=GridBagConstraints.CENTER;
		layoutGraficos3D.setConstraints(panelGraficos23D, c);
		
		panelGraficos3D.add(panelGraficos23D);
		
		c.gridwidth = 1;
		layoutGraficos3D.setConstraints(labelLetraEjes3D, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutGraficos3D.setConstraints(cambiarGraficos53D, c);
		
		panelGraficos3D.add(labelLetraEjes3D);
		panelGraficos3D.add(cambiarGraficos53D);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutGraficos3D.setConstraints(panelMuestra3D, c);
		
		panelGraficos3D.add(panelMuestra3D);
		
		//SE CONSTRUYE EL PANEL PARA LAS OPCIONES GRÁFICAS AVANZADOS EN 3D
		
		labelpixelesMarcasX3D=new JLabel("Pixeles a los que se pone cada marca en el eje X");
		labelpixelesMarcasY3D=new JLabel("Pixeles a los que se pone cada marca en el eje Y");
		labelpixelesMarcasZ3D=new JLabel("Pixeles a los que se pone cada marca en el eje Y");
		
		pixelesMarcasX3D=Opciones.getPixelesMarcasX3D();
		pixelesMarcasY3D=Opciones.getPixelesMarcasY3D();
		pixelesMarcasZ3D=Opciones.getPixelesMarcasZ3D();
		
		SpinnerNumberModel model13D=new SpinnerNumberModel(pixelesMarcasX3D, 1, 500, 1);
		spinnerPixelesMarcasX3D=new JSpinner(model13D);
		spinnerPixelesMarcasX3D.addChangeListener(this);

		SpinnerNumberModel model23D=new SpinnerNumberModel(pixelesMarcasY3D, 1, 500, 1);
		spinnerPixelesMarcasY3D=new JSpinner(model23D);
		spinnerPixelesMarcasY3D.addChangeListener(this);
		
		SpinnerNumberModel model33D=new SpinnerNumberModel(pixelesMarcasZ3D, 1, 500, 1);
		spinnerPixelesMarcasZ3D=new JSpinner(model33D);
		spinnerPixelesMarcasZ3D.addChangeListener(this);
		
		layoutGraficosAvanzados3D=new GridBagLayout();
		
		panelGraficosAvanzados3D=new JPanel(layoutGraficosAvanzados3D);
		panelGraficosAvanzados3D.setBorder(new EmptyBorder(5,5,5,5));
		
		c.gridwidth = 1;
		layoutGraficosAvanzados3D.setConstraints(labelCantidadPuntos3D, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutGraficosAvanzados3D.setConstraints(spinnerPuntos3D, c);
		
		c.gridwidth = 1;
		layoutGraficosAvanzados3D.setConstraints(labelpixelesMarcasX3D, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutGraficosAvanzados3D.setConstraints(spinnerPixelesMarcasX3D, c);
		
		c.gridwidth = 1;
		layoutGraficosAvanzados3D.setConstraints(labelpixelesMarcasY3D, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutGraficosAvanzados3D.setConstraints(spinnerPixelesMarcasY3D, c);
		
		c.gridwidth = 1;
		layoutGraficosAvanzados3D.setConstraints(labelpixelesMarcasZ3D, c);
		
		c.gridwidth = GridBagConstraints.REMAINDER;
		layoutGraficosAvanzados3D.setConstraints(spinnerPixelesMarcasZ3D, c);
		
		panelGraficosAvanzados3D.add(labelCantidadPuntos3D);
		panelGraficosAvanzados3D.add(spinnerPuntos3D);
		panelGraficosAvanzados3D.add(labelpixelesMarcasX3D);
		panelGraficosAvanzados3D.add(spinnerPixelesMarcasX3D);
		panelGraficosAvanzados3D.add(labelpixelesMarcasY3D);
		panelGraficosAvanzados3D.add(spinnerPixelesMarcasY3D);
		panelGraficosAvanzados3D.add(labelpixelesMarcasZ3D);
		panelGraficosAvanzados3D.add(spinnerPixelesMarcasZ3D);
		
		colorFondo=Opciones.getColorFondo();
		
		//SE CONSTRUYE EL TABPANEL PARA LAS OPCIONES
		
		pestanaPanel = new JTabbedPane();
		
		pestanaPanel.addTab("Matemáticas", panelMatematicas);
		pestanaPanel.addTab("Apariencia", panelApariencia);
		pestanaPanel.addTab("Gráficas", panelGraficos);
		pestanaPanel.addTab("Gráficas (Avanzadas)", panelGraficosAvanzados);
		pestanaPanel.addTab("Gráficas 3D", panelGraficos3D);
		pestanaPanel.addTab("Gráficas 3D (Avanzadas)", panelGraficosAvanzados3D);
		
		this.add(pestanaPanel, BorderLayout.CENTER);
		
		panelBotones=new JPanel();
		panelBotones.setLayout(new GridLayout(1,3));
		
		botonAceptar=new JButton("Aceptar");
		botonAceptar.setMnemonic('A');
		botonCancelar=new JButton("Cancelar");
		botonCancelar.setMnemonic('C');
		botonPredeterminado=new JButton("Predeterminado");
		botonPredeterminado.setMnemonic('P');
		botonAceptar.addActionListener(this);
		botonCancelar.addActionListener(this);
		botonPredeterminado.addActionListener(this);
		
		panelBotones.add(botonAceptar);
		panelBotones.add(botonCancelar);
		panelBotones.add(botonPredeterminado);
		
		this.add(panelBotones, BorderLayout.SOUTH);
		
		this.setVisible(true);
	}
	
	//AUDITORES DE EVENTOS
	
	public void actionPerformed( ActionEvent evt ) {
		
		//Auditor para los eventos de los botones principales
		
		if(evt.getSource()==botonAceptar){
			if(aspecto!=null){
				Opciones.setAspecto(aspecto);
			}
			if(colorLetra!=null){
				Opciones.setColorLetra(colorLetra);
			}
			if(colorFondo!=null){
				Opciones.setColorFondo(colorFondo);
			}
			if(tipoLetra!=null){
				Opciones.setTipoLetra(tipoLetra);
			}
			if(colorFondoGrafica!=null){
				Opciones.setColorFondoGrafica(colorFondoGrafica);
			}
			if(colorEjesGrafica!=null){
				Opciones.setColorEjesGrafica(colorEjesGrafica);
			}
			if(colorEjesAtenuadosGrafica!=null){
				Opciones.setColorEjesAtenuadosGrafica(colorEjesAtenuadosGrafica);
			}
			if(colorFijo!=null){
				Opciones.setColorGrafica(colorFijo);
			}
			if(tipoLetraEjes!=null){
				Opciones.setTipoLetraEjesGrafica(tipoLetraEjes);
			}
			if(colorFondoGrafica3D!=null){
				Opciones.setColorFondoGrafica3D(colorFondoGrafica3D);
			}
			if(colorEjesGrafica3D!=null){
				Opciones.setColorEjesGrafica3D(colorEjesGrafica3D);
			}
			if(colorEjesAtenuadosGrafica3D!=null){
				Opciones.setColorEjesAtenuadosGrafica3D(colorEjesAtenuadosGrafica3D);
			}
			if(colorFijo3D!=null){
				Opciones.setColorGrafica3D(colorFijo3D);
			}
			if(tipoLetraEjes3D!=null){
				Opciones.setTipoLetraEjesGrafica3D(tipoLetraEjes3D);
			}
			
			Opciones.setPresicion(exacta);
			Opciones.setNumDecimales(decimales+10);
			Opciones.setAngulo(radianes);
			Opciones.setAlternarColorGrafica(alternar);
			Opciones.setNumPuntosGrafica(numPuntos);
			Opciones.setPixelesMarcasX(pixelesMarcasX);
			Opciones.setPixelesMarcasY(pixelesMarcasY);
			Opciones.setAlternarColorGrafica3D(alternar3D);
			Opciones.setNumPuntosGrafica3D(numPuntos3D);
			Opciones.setPixelesMarcasX3D(pixelesMarcasX3D);
			Opciones.setPixelesMarcasY3D(pixelesMarcasY3D);
			Opciones.setPixelesMarcasZ3D(pixelesMarcasZ3D);
			estaJDialog.dispose();
		}else if(evt.getSource()==botonCancelar){
			aspecto=Opciones.getAspecto();
			try{
				if(aspecto.equals("Metal")){
					UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
				}else if(aspecto.equals("Native")){
					UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
				}else if(aspecto.equals("Motif")){
					UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
				}
			}catch(Exception e){ e.printStackTrace(); }
			estaJDialog.dispose();
		}else if(evt.getSource()==botonPredeterminado){
			spinnerDecimales.setValue(6);
			spinnerDecimales.setEnabled(false);
			radioExacta.setSelected(true);
			radioRadianes.setSelected(true);
			colorFondo=new Color(238,238,238);
			panelVistaPrevia.setBackground(new Color(238,238,238));
			tipoLetra=new Font(null,Font.PLAIN, 12);
			vistaPrevia.setFont(new Font(null,Font.PLAIN, 12));
			colorLetra=new Color(0,0,0);
			vistaPrevia.setForeground(new Color(0,0,0));
			comboApariencia.setSelectedItem("Metal");
			colorFondoGrafica=Color.WHITE;
			panelMuestra.setColorFondo(colorFondoGrafica);
			colorEjesGrafica=Color.GRAY;
			panelMuestra.setColorEjes(colorEjesGrafica);
			colorEjesAtenuadosGrafica=Color.LIGHT_GRAY;
			panelMuestra.setColorEjesAtenuados(colorEjesAtenuadosGrafica);
			colorFijo=Color.BLUE;
			panelMuestra.setColorGrafica(colorFijo);
			tipoLetraEjes=new Font(null,Font.PLAIN, 12);
			panelMuestra.setTipoLetra(tipoLetraEjes);
			alternar=true;
			numPuntos=10;
			spinnerPuntos.setValue(10);
			decimales=16;
			exacta=true;
			radianes=true;
			aspecto="Metal";
			spinnerPixelesMarcasX.setValue(40);
			pixelesMarcasX=40;
			spinnerPixelesMarcasY.setValue(40);
			pixelesMarcasY=40;
			colorFondoGrafica3D=Color.WHITE;
			panelMuestra3D.setColorFondo(colorFondoGrafica3D);
			colorEjesGrafica3D=Color.GRAY;
			panelMuestra3D.setColorEjes(colorEjesGrafica3D);
			colorEjesAtenuadosGrafica3D=Color.LIGHT_GRAY;
			panelMuestra3D.setColorEjesAtenuados(colorEjesAtenuadosGrafica3D);
			colorFijo3D=Color.BLUE;
			panelMuestra3D.setColorGrafica(colorFijo3D);
			tipoLetraEjes3D=new Font(null,Font.PLAIN, 12);
			panelMuestra3D.setTipoLetra(tipoLetraEjes3D);
			alternar3D=true;
			numPuntos3D=10;
			spinnerPixelesMarcasX3D.setValue(40);
			pixelesMarcasX3D=40;
			spinnerPixelesMarcasY3D.setValue(40);
			pixelesMarcasY3D=40;
			spinnerPixelesMarcasZ3D.setValue(40);
			pixelesMarcasZ3D=40;
		}
		
		//Auditor para los eventos del panel de opciones matemáticas
		
		if(evt.getSource()==radioExacta){
			spinnerDecimales.setEnabled(false);
			exacta=true;
		}else if(evt.getSource()==radioAproximada){
			spinnerDecimales.setEnabled(true);
			exacta=false;
		}else if(evt.getSource()==radioRadianes){
			radianes=true;
		}else if(evt.getSource()==radioGrados){
			radianes=false;
		}
		
		//Auditor para los eventos del panel de apariencia
		
		if(evt.getSource()==cambiar1){
			//JColorChooser colores=new JColorChooser();
			Color colorEscogido;
		
			colorEscogido=JColorChooser.showDialog(estaJDialog, "Escoja un color...", colorFondo);
			if(colorEscogido!=null){
				colorFondo=colorEscogido;
				panelVistaPrevia.setBackground(colorFondo);
			}
		}else if(evt.getSource()==cambiar2){
			//JColorChooser colores=new JColorChooser();
			Color colorEscogido;
			
			colorEscogido=JColorChooser.showDialog(estaJDialog, "Escoja un color...", colorLetra);
			if(colorEscogido!=null){
				colorLetra=colorEscogido;
				vistaPrevia.setForeground(colorLetra);
			}
		}else if(evt.getSource()==cambiar3){
			FontChooser fontChooser=new FontChooser(this, "Fuente...", Opciones.getTipoLetra());
			fontChooser.showDialog("Formato de Fuente...");
			if(fontChooser.getBotonPresionado()){
				Font letraEscogida=fontChooser.getSelectedFont();
				if(letraEscogida!=null){
					tipoLetra=letraEscogida;
					vistaPrevia.setFont(tipoLetra);
				}
			}
		}
		
		//Auditor para los eventos del panel de opciones de Apariencia
		
		if(evt.getSource()==comboApariencia){
			aspecto=(String)comboApariencia.getSelectedItem();
			try{
				if(aspecto.equals("Metal")){
					UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
					SwingUtilities.updateComponentTreeUI(estaJDialog);
					if(panelVistaPrevia!=null)
						panelVistaPrevia.setBackground(new Color(238,238,238));
					colorFondo=new Color(238,238,238);
				}else if(aspecto.equals("Native")){
					UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
					SwingUtilities.updateComponentTreeUI(estaJDialog);
					if(panelVistaPrevia!=null)
						panelVistaPrevia.setBackground(new Color(236,233,216));
					colorFondo=new Color(236,233,216);
				}else if(aspecto.equals("Motif")){
					UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
					SwingUtilities.updateComponentTreeUI(estaJDialog);
					if(panelVistaPrevia!=null)
						panelVistaPrevia.setBackground(new Color(174,178,195));
					colorFondo=new Color(174,178,195);
				}
			}catch(Exception e){ e.printStackTrace(); }
		}
		
		//Auditor para los eventos del panel de Gráficos
		
		if(evt.getSource()==radioColorAlternar){
			cambiarGraficos4.setEnabled(false);
			alternar=true;
			panelMuestra.setAlternarColor(alternar);
		}else if(evt.getSource()==radioColorFijo){
			cambiarGraficos4.setEnabled(true);
			alternar=false;
			panelMuestra.setAlternarColor(alternar);
		}else if(evt.getSource()==cambiarGraficos1){
			//JColorChooser colores=new JColorChooser();
			Color colorEscogido;
			
			colorEscogido=JColorChooser.showDialog(estaJDialog, "Escoja un color...", colorLetra);
			if(colorEscogido!=null){
				colorFondoGrafica=colorEscogido;
				panelMuestra.setColorFondo(colorFondoGrafica);
			}
		}else if(evt.getSource()==cambiarGraficos2){
			//JColorChooser colores=new JColorChooser();
			Color colorEscogido;
			
			colorEscogido=JColorChooser.showDialog(estaJDialog, "Escoja un color...", colorLetra);
			if(colorEscogido!=null){
				colorEjesGrafica=colorEscogido;
				panelMuestra.setColorEjes(colorEjesGrafica);
			}
		}else if(evt.getSource()==cambiarGraficos3){
			//JColorChooser colores=new JColorChooser();
			Color colorEscogido;
			
			colorEscogido=JColorChooser.showDialog(estaJDialog, "Escoja un color...", colorLetra);
			if(colorEscogido!=null){
				colorEjesAtenuadosGrafica=colorEscogido;
				panelMuestra.setColorEjesAtenuados(colorEjesAtenuadosGrafica);
			}
		}else if(evt.getSource()==cambiarGraficos4){
			//JColorChooser colores=new JColorChooser();
			Color colorEscogido;
			
			colorEscogido=JColorChooser.showDialog(estaJDialog, "Escoja un color...", colorLetra);
			if(colorEscogido!=null){
				colorFijo=colorEscogido;
				panelMuestra.setColorGrafica(colorFijo);
			}
		}else if(evt.getSource()==cambiarGraficos5){
			FontChooser fontChooser=new FontChooser(this, "Fuente...", Opciones.getTipoLetraEjesGrafica());
			fontChooser.showDialog("Formato de Fuente...");
			if(fontChooser.getBotonPresionado()){
				Font letraEscogida=fontChooser.getSelectedFont();
				if(letraEscogida!=null){
					tipoLetraEjes=letraEscogida;
					panelMuestra.setTipoLetra(tipoLetraEjes);
				}
			}
		}else if(evt.getSource()==radioColorAlternar3D){
			cambiarGraficos43D.setEnabled(false);
			alternar3D=true;
			panelMuestra3D.setAlternarColor(alternar3D);
		}else if(evt.getSource()==radioColorFijo3D){
			cambiarGraficos43D.setEnabled(true);
			alternar3D=false;
			panelMuestra3D.setAlternarColor(alternar3D);
		}else if(evt.getSource()==cambiarGraficos13D){
			//JColorChooser colores=new JColorChooser();
			Color colorEscogido;
			
			colorEscogido=JColorChooser.showDialog(estaJDialog, "Escoja un color...", colorLetra);
			if(colorEscogido!=null){
				colorFondoGrafica3D=colorEscogido;
				panelMuestra3D.setColorFondo(colorFondoGrafica3D);
			}
		}else if(evt.getSource()==cambiarGraficos23D){
			//JColorChooser colores=new JColorChooser();
			Color colorEscogido;
			
			colorEscogido=JColorChooser.showDialog(estaJDialog, "Escoja un color...", colorLetra);
			if(colorEscogido!=null){
				colorEjesGrafica3D=colorEscogido;
				panelMuestra3D.setColorEjes(colorEjesGrafica3D);
			}
		}else if(evt.getSource()==cambiarGraficos33D){
			//JColorChooser colores=new JColorChooser();
			Color colorEscogido;
			
			colorEscogido=JColorChooser.showDialog(estaJDialog, "Escoja un color...", colorLetra);
			if(colorEscogido!=null){
				colorEjesAtenuadosGrafica3D=colorEscogido;
				panelMuestra3D.setColorEjesAtenuados(colorEjesAtenuadosGrafica3D);
			}
		}else if(evt.getSource()==cambiarGraficos43D){
			//JColorChooser colores=new JColorChooser();
			Color colorEscogido;
			
			colorEscogido=JColorChooser.showDialog(estaJDialog, "Escoja un color...", colorLetra);
			if(colorEscogido!=null){
				colorFijo3D=colorEscogido;
				panelMuestra3D.setColorGrafica(colorFijo3D);
			}
		}else if(evt.getSource()==cambiarGraficos53D){
			FontChooser fontChooser=new FontChooser(this, "Fuente...", Opciones.getTipoLetraEjesGrafica3D());
			fontChooser.showDialog("Formato de Fuente...");
			if(fontChooser.getBotonPresionado()){
				Font letraEscogida=fontChooser.getSelectedFont();
				if(letraEscogida!=null){
					tipoLetraEjes3D=letraEscogida;
					panelMuestra.setTipoLetra(tipoLetraEjes3D);
				}
			}
		}
	}
	
	public void stateChanged( ChangeEvent evt ) {
		
		//Auditor para los eventos del JSpinner del número de decimales
		
		if(evt.getSource()==spinnerDecimales && spinnerDecimales.isEnabled()){
			decimales=((Integer)spinnerDecimales.getValue()).intValue();
		}
		
		//Auditor para los eventos de los JSpinner para la gráfica
		
		if(evt.getSource()==spinnerPuntos){
			try {
				numPuntos=((Integer)spinnerPuntos.getValue()).intValue();
				if(numPuntos<1 || numPuntos>100){
					numPuntos=5;
					spinnerPuntos.setValue(5);
				}
			}catch (Exception e){
				numPuntos=5;
				spinnerPuntos.setValue(5);
			}
		}else if(evt.getSource()==spinnerPixelesMarcasX){
			try {
				pixelesMarcasX=((Integer)spinnerPixelesMarcasX.getValue()).intValue();
				if(pixelesMarcasX<1 || pixelesMarcasX>500){
					pixelesMarcasX=40;
					spinnerPixelesMarcasX.setValue(40);
				}
			}catch (Exception e){
				pixelesMarcasX=40;
				spinnerPixelesMarcasX.setValue(40);
			}
		}else if(evt.getSource()==spinnerPixelesMarcasY){
			try {
				pixelesMarcasY=((Integer)spinnerPixelesMarcasY.getValue()).intValue();
				if(pixelesMarcasY<1 || pixelesMarcasY>500){
					pixelesMarcasY=40;
					spinnerPixelesMarcasY.setValue(40);
				}
			}catch (Exception e){
				pixelesMarcasY=40;
				spinnerPixelesMarcasX.setValue(40);
			}
		}else if(evt.getSource()==spinnerPuntos3D){ //OPCIONES GRAFICA 3D
			try {
				numPuntos3D=((Integer)spinnerPuntos3D.getValue()).intValue();
				if(numPuntos3D<1 || numPuntos3D>100){
					numPuntos3D=5;
					spinnerPuntos3D.setValue(5);
				}
			}catch (Exception e){
				numPuntos3D=5;
				spinnerPuntos3D.setValue(5);
			}
		}else if(evt.getSource()==spinnerPixelesMarcasX3D){
			try {
				pixelesMarcasX3D=((Integer)spinnerPixelesMarcasX3D.getValue()).intValue();
				if(pixelesMarcasX3D<1 || pixelesMarcasX3D>500){
					pixelesMarcasX3D=40;
					spinnerPixelesMarcasX3D.setValue(40);
				}
			}catch (Exception e){
				pixelesMarcasX3D=40;
				spinnerPixelesMarcasX3D.setValue(40);
			}
		}else if(evt.getSource()==spinnerPixelesMarcasY3D){
			try {
				pixelesMarcasY3D=((Integer)spinnerPixelesMarcasY3D.getValue()).intValue();
				if(pixelesMarcasY3D<1 || pixelesMarcasY3D>500){
					pixelesMarcasY3D=40;
					spinnerPixelesMarcasY3D.setValue(40);
				}
			}catch (Exception e){
				pixelesMarcasY3D=40;
				spinnerPixelesMarcasX3D.setValue(40);
			}
		}else if(evt.getSource()==spinnerPixelesMarcasZ3D){
			try {
				pixelesMarcasZ3D=((Integer)spinnerPixelesMarcasZ3D.getValue()).intValue();
				if(pixelesMarcasZ3D<1 || pixelesMarcasZ3D>500){
					pixelesMarcasZ3D=40;
					spinnerPixelesMarcasZ3D.setValue(40);
				}
			}catch (Exception e){
				pixelesMarcasZ3D=40;
				spinnerPixelesMarcasZ3D.setValue(40);
			}
		}
	}
	
}//Fin de Opciones