package itcr.mathexplorer.tablas;

import java.util.Hashtable;
import itcr.mathexplorer.constantes.Constantes;

/**
 *@(#)TablaConstantes.java
 *
 *Clase que construye una tabla de Hash para que se escriban en ella
 *todas las constantes disponibles en el programa.
 *
 *@author Alexander Borbón Alpízar
 */
public class TablaConstantes extends Hashtable<String, Constantes>{
	static final long serialVersionUID=10008;
	
	//CONSTRUCTORES
	/**
	 * Constructor vacío de la Tabla donde se guardan las constantes del programa.
	 */
	public TablaConstantes(){	}


	//FUNCIONES PUBLICAS
	
	
	/** 
	 *Agrega a la tabla de constantes un nuevo operador
	 *@param llave La llave asociada a la constantes introducida
	 *@param nuevaConstante La nueva constante introducida
	 *@return El valor previo que había en la llave seleccionada o null si no había nada
	 */
	public Object agregaConstante(String llave, Constantes nuevaConstante)
	{
		return super.put(llave, nuevaConstante);
	}
	
	/**
	 *Devuelve la constante asociada a la llave
	 *@param llave La llave asociada a la constante buscada
	 *@return La constante asociada con la llave dada
	 */
	public Constantes devuelveConstante(String llave)
	{
		return (Constantes)super.get(llave);
	}
	
	/**
	 *Esta función busca si en esta tabla se encuentra la llave buscada
	 *@param llave La llave que se busca en la tabla
	 *@return Devuelve true si la llave aparece o false si no aparece.
	 */
	public boolean apareceLlave(String llave){
		return super.containsKey(llave);
	}
	
	/**
	 *Esta función da el número de constantes que están actualmente en la tabla.
	 *@return El número de constantes que están en la tabla.
	 */
	public int numeroConstantes(){
		return super.size();
	}

}//fin de TablaConstantes