package itcr.mathexplorer.tablas;

import java.util.Hashtable;
import itcr.mathexplorer.operadores.Operadores;

/**
 *@(#)TablaOperadores.java
 *
 *Clase que construye una tabla de Hash para que se escriban en ella
 *todas las funciones disponibles en el programa.
 *
 *@author Alexander Borbón Alpízar
 */
public class TablaOperadores extends Hashtable<String, Operadores>{
	static final long serialVersionUID=10011;
	
	//CONSTRUCTORES
	/**
	 * Constructor vacío de la Tabla donde se guardan los operadores del programa.
	 */
	public TablaOperadores(){	}


	//FUNCIONES PUBLICAS
	
	
	/** 
	 *Agrega a la tabla de operadores un nuevo operador
	 *@param llave La llave asociada al operador introducido
	 *@param nuevoOperador El nuevo operador introducido
	 *@return El valor previo que había en la llave seleccionada o null si no había nada
	 */
	public Object agregaOperador(String llave, Operadores nuevoOperador)
	{
		return super.put(llave, nuevoOperador);
	}
	
	/**
	 *Devuelve el operador asociado a la llave
	 *@param llave La llave asociada al operador buscado
	 *@return El operador asociado con la llave dada
	 */
	public Operadores devuelveOperador(String llave)
	{
		return (Operadores)super.get(llave);
	}
	
	/**
	 *Esta función busca si en esta tabla se encuentra la llave buscada
	 *@param llave La llave que se busca en la tabla
	 *@return Devuelve true si la llave aparece o false si no aparece.
	 */
	public boolean apareceLlave(String llave){
		return super.containsKey(llave);
	}
	
	/**
	 *Esta función da el número de operadores que están actualmente en la tabla.
	 *@return El número de operadores que están en la tabla.
	 */
	public int numeroOperadores(){
		return super.size();
	}

}//fin de TablaFunciones