package itcr.mathexplorer.tipos;

import java.io.File;
import javax.swing.filechooser.*;

/**
 *@(#)MiFileFilter.java
 *
 *Este es el filtro de extensiones para búsqueda y guardado de archivos.
 *
 *@author Alexander Borbón Alpízar
 */
public class MiFileFilter extends FileFilter {
	/**
	 * El String que contiene la extensión de archivo por defecto del programa.
	 */
	public static String extensionStr = "mae";
	/**
	 * El String que contiene la expresión a mostrar en las opciones de la ventana.
	 */
	public String cadena = " MathExplorer(*.mae)";
	
	/**
	 * Constructor vacío del filtro de extensiones.
	 */
	public MiFileFilter(){
		extensionStr = "mae";
		cadena = " MathExplorer(*.mae)";
	}// fin de constructor
	
	/**
	 * Constructor que recibe una nueva extensión y un nuevo mensaje a mostrar.
	 * @param ext La nueva extensión a utilizar.
	 * @param cad El nuevo mensaje a mostrar.
	 */
	public MiFileFilter(String ext, String cad){
		extensionStr = ext;
		cadena = cad;
	}// fin de constructor

	// Accept all directories and all extensionStr files.
	public boolean accept(File f) {
		if(f.isDirectory()){ return true; }

		String extension = getExtension(f);
		if(extension != null) {
			return extension.equals(extensionStr);
		}
		return false;
	}// fin de accept

	// The description of this filter
	public String getDescription(){ return cadena; }

	/**
	 * Método para obtener la extensión de un archivo.
	 * @param f File para obtener la extensión.
	 * @return La extensión del archivo.
	 */
	public static String getExtension(File f) {
		String ext = null;
		String s = f.getName();
		int i = s.lastIndexOf('.');

		if(i > 0 &&  i < s.length() - 1){
			ext = s.substring(i+1).toLowerCase();
		}
		return ext;
	}// fin de getExtension

}//MyFileFilter